diff --git a/compiler/deSugar/DsArrows.lhs b/compiler/deSugar/DsArrows.lhs
index 4034b6d..f1a81af 100644
--- a/compiler/deSugar/DsArrows.lhs
+++ b/compiler/deSugar/DsArrows.lhs
@@ -1067,13 +1061,13 @@ List of leaf expressions, with set of variables bound in each
 leavesMatch :: LMatch Id (Located (body Id)) -> [(Located (body Id), IdSet)]
 leavesMatch (L _ (Match pats _ (GRHSs grhss binds)))
   = let
-	defined_vars = mkVarSet (collectPatsBinders pats)
-			`unionVarSet`
-		       mkVarSet (collectLocalBinders binds)
+        defined_vars = mkVarSet (collectPatsBinders pats)
+                        `unionVarSet`
+                       mkVarSet (collectLocalBinders binds)
     in
     [(body, 
       mkVarSet (collectLStmtsBinders stmts) 
-	`unionVarSet` defined_vars) 
+        `unionVarSet` defined_vars) 
     | L _ (GRHS stmts body) <- grhss]
 \end{code}
 
@@ -1088,7 +1082,7 @@ replaceLeavesMatch
             LMatch Id (Located (body' Id)))     -- updated match
 replaceLeavesMatch _res_ty leaves (L loc (Match pat mt (GRHSs grhss binds)))
   = let
-	(leaves', grhss') = mapAccumL replaceLeavesGRHS leaves grhss
+        (leaves', grhss') = mapAccumL replaceLeavesGRHS leaves grhss
     in
     (leaves', L loc (Match pat mt (GRHSs grhss' binds)))
 
diff --git a/compiler/deSugar/DsBinds.lhs b/compiler/deSugar/DsBinds.lhs
index a33ff91..cb0e2c6 100644
--- a/compiler/deSugar/DsBinds.lhs
+++ b/compiler/deSugar/DsBinds.lhs
@@ -10,12 +10,6 @@ in that the @Rec@/@NonRec@/etc structure is thrown away (whereas at
 lower levels it is preserved with @let@/@letrec@s).
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module DsBinds ( dsTopLHsBinds, dsLHsBinds, decomposeRuleLhs, dsSpec,
                  dsHsWrapper, dsTcEvBinds, dsEvBinds
@@ -23,15 +17,15 @@ module DsBinds ( dsTopLHsBinds, dsLHsBinds, decomposeRuleLhs, dsSpec,
 
 #include "HsVersions.h"
 
-import {-# SOURCE #-}	DsExpr( dsLExpr )
-import {-# SOURCE #-}	Match( matchWrapper )
+import {-# SOURCE #-}   DsExpr( dsLExpr )
+import {-# SOURCE #-}   Match( matchWrapper )
 
 import DsMonad
 import DsGRHSs
 import DsUtils
 
-import HsSyn		-- lots of things
-import CoreSyn		-- lots of things
+import HsSyn            -- lots of things
+import CoreSyn          -- lots of things
 import Literal          ( Literal(MachStr) )
 import CoreSubst
 import MkCore
@@ -52,9 +46,9 @@ import Coercion hiding (substCo)
 import TysWiredIn ( eqBoxDataCon, coercibleTyCon, coercibleDataCon, tupleCon )
 import Id
 import Class
-import DataCon	( dataConWorkId )
+import DataCon  ( dataConWorkId )
 import Name
-import MkId	( seqId )
+import MkId     ( seqId )
 import Var
 import VarSet
 import Rules
@@ -77,9 +71,9 @@ import Control.Monad(liftM)
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection[dsMonoBinds]{Desugaring a @MonoBinds@}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -106,17 +100,17 @@ dsHsBind (VarBind { var_id = var, var_rhs = expr, var_inline = inline_regardless
   = do  { dflags <- getDynFlags
         ; core_expr <- dsLExpr expr
 
-	        -- Dictionary bindings are always VarBinds,
-	        -- so we only need do this here
+                -- Dictionary bindings are always VarBinds,
+                -- so we only need do this here
         ; let var' | inline_regardless = var `setIdUnfolding` mkCompulsoryUnfolding core_expr
-	      	   | otherwise         = var
+                   | otherwise         = var
 
         ; return (unitOL (makeCorePair dflags var' False 0 core_expr)) }
 
 dsHsBind (FunBind { fun_id = L _ fun, fun_matches = matches
                   , fun_co_fn = co_fn, fun_tick = tick
                   , fun_infix = inf })
- = do	{ dflags <- getDynFlags
+ = do   { dflags <- getDynFlags
         ; (args, body) <- matchWrapper (FunRhs (idName fun) inf) matches
         ; let body' = mkOptTickBox tick body
         ; rhs <- dsHsWrapper co_fn (mkLams args body')
@@ -125,17 +119,17 @@ dsHsBind (FunBind { fun_id = L _ fun, fun_matches = matches
 
 dsHsBind (PatBind { pat_lhs = pat, pat_rhs = grhss, pat_rhs_ty = ty
                   , pat_ticks = (rhs_tick, var_ticks) })
-  = do	{ body_expr <- dsGuarded grhss ty
+  = do  { body_expr <- dsGuarded grhss ty
         ; let body' = mkOptTickBox rhs_tick body_expr
         ; sel_binds <- mkSelectorBinds var_ticks pat body'
-	  -- We silently ignore inline pragmas; no makeCorePair
-	  -- Not so cool, but really doesn't matter
+          -- We silently ignore inline pragmas; no makeCorePair
+          -- Not so cool, but really doesn't matter
     ; return (toOL sel_binds) }
 
-	-- A common case: one exported variable
-	-- Non-recursive bindings come through this way
-	-- So do self-recursive bindings, and recursive bindings
-	-- that have been chopped up with type signatures
+        -- A common case: one exported variable
+        -- Non-recursive bindings come through this way
+        -- So do self-recursive bindings, and recursive bindings
+        -- that have been chopped up with type signatures
 dsHsBind (AbsBinds { abs_tvs = tyvars, abs_ev_vars = dicts
                    , abs_exports = [export]
                    , abs_ev_binds = ev_binds, abs_binds = binds })
@@ -143,21 +137,21 @@ dsHsBind (AbsBinds { abs_tvs = tyvars, abs_ev_vars = dicts
         , abe_mono = local, abe_prags = prags } <- export
   = do  { dflags <- getDynFlags
         ; bind_prs    <- ds_lhs_binds binds
-	; let	core_bind = Rec (fromOL bind_prs)
+        ; let   core_bind = Rec (fromOL bind_prs)
         ; ds_binds <- dsTcEvBinds ev_binds
         ; rhs <- dsHsWrapper wrap $  -- Usually the identity
-			    mkLams tyvars $ mkLams dicts $ 
-	                    mkCoreLets ds_binds $
+                            mkLams tyvars $ mkLams dicts $ 
+                            mkCoreLets ds_binds $
                             Let core_bind $
                             Var local
     
-	; (spec_binds, rules) <- dsSpecs rhs prags
+        ; (spec_binds, rules) <- dsSpecs rhs prags
 
-	; let   global'   = addIdSpecialisations global rules
-		main_bind = makeCorePair dflags global' (isDefaultMethod prags)
+        ; let   global'   = addIdSpecialisations global rules
+                main_bind = makeCorePair dflags global' (isDefaultMethod prags)
                                          (dictArity dicts) rhs 
     
-	; return (main_bind `consOL` spec_binds) }
+        ; return (main_bind `consOL` spec_binds) }
 
 dsHsBind (AbsBinds { abs_tvs = tyvars, abs_ev_vars = dicts
                    , abs_exports = exports, abs_ev_binds = ev_binds
@@ -167,39 +161,39 @@ dsHsBind (AbsBinds { abs_tvs = tyvars, abs_ev_vars = dicts
         ; bind_prs    <- ds_lhs_binds binds
         ; let core_bind = Rec [ makeCorePair dflags (add_inline lcl_id) False 0 rhs
                               | (lcl_id, rhs) <- fromOL bind_prs ]
-	      	-- Monomorphic recursion possible, hence Rec
+                -- Monomorphic recursion possible, hence Rec
 
-	      locals       = map abe_mono exports
-	      tup_expr     = mkBigCoreVarTup locals
-	      tup_ty	   = exprType tup_expr
+              locals       = map abe_mono exports
+              tup_expr     = mkBigCoreVarTup locals
+              tup_ty       = exprType tup_expr
         ; ds_binds <- dsTcEvBinds ev_binds
-	; let poly_tup_rhs = mkLams tyvars $ mkLams dicts $
-	      		     mkCoreLets ds_binds $
-			     Let core_bind $
-	 	     	     tup_expr
+        ; let poly_tup_rhs = mkLams tyvars $ mkLams dicts $
+                             mkCoreLets ds_binds $
+                             Let core_bind $
+                             tup_expr
 
-	; poly_tup_id <- newSysLocalDs (exprType poly_tup_rhs)
+        ; poly_tup_id <- newSysLocalDs (exprType poly_tup_rhs)
 
-	; let mk_bind (ABE { abe_wrap = wrap, abe_poly = global
+        ; let mk_bind (ABE { abe_wrap = wrap, abe_poly = global
                            , abe_mono = local, abe_prags = spec_prags })
-	        = do { tup_id  <- newSysLocalDs tup_ty
-	             ; rhs <- dsHsWrapper wrap $ 
+                = do { tup_id  <- newSysLocalDs tup_ty
+                     ; rhs <- dsHsWrapper wrap $ 
                                  mkLams tyvars $ mkLams dicts $
-	      	     		 mkTupleSelector locals local tup_id $
-			         mkVarApps (Var poly_tup_id) (tyvars ++ dicts)
+                                 mkTupleSelector locals local tup_id $
+                                 mkVarApps (Var poly_tup_id) (tyvars ++ dicts)
                      ; let rhs_for_spec = Let (NonRec poly_tup_id poly_tup_rhs) rhs
-		     ; (spec_binds, rules) <- dsSpecs rhs_for_spec spec_prags
-		     ; let global' = (global `setInlinePragma` defaultInlinePragma)
+                     ; (spec_binds, rules) <- dsSpecs rhs_for_spec spec_prags
+                     ; let global' = (global `setInlinePragma` defaultInlinePragma)
                                              `addIdSpecialisations` rules
                            -- Kill the INLINE pragma because it applies to
                            -- the user written (local) function.  The global
                            -- Id is just the selector.  Hmm.  
-		     ; return ((global', rhs) `consOL` spec_binds) }
+                     ; return ((global', rhs) `consOL` spec_binds) }
 
         ; export_binds_s <- mapM mk_bind exports
 
-	; return ((poly_tup_id, poly_tup_rhs) `consOL` 
-		    concatOL export_binds_s) }
+        ; return ((poly_tup_id, poly_tup_rhs) `consOL` 
+                    concatOL export_binds_s) }
   where
     inline_env :: IdEnv Id   -- Maps a monomorphic local Id to one with
                              -- the inline pragma from the source
@@ -215,14 +209,14 @@ dsHsBind (AbsBinds { abs_tvs = tyvars, abs_ev_vars = dicts
 ------------------------
 makeCorePair :: DynFlags -> Id -> Bool -> Arity -> CoreExpr -> (Id, CoreExpr)
 makeCorePair dflags gbl_id is_default_method dict_arity rhs
-  | is_default_method		      -- Default methods are *always* inlined
+  | is_default_method                 -- Default methods are *always* inlined
   = (gbl_id `setIdUnfolding` mkCompulsoryUnfolding rhs, rhs)
 
   | otherwise
   = case inlinePragmaSpec inline_prag of
-      	  EmptyInlineSpec -> (gbl_id, rhs)
-      	  NoInline        -> (gbl_id, rhs)
-      	  Inlinable       -> (gbl_id `setIdUnfolding` inlinable_unf, rhs)
+          EmptyInlineSpec -> (gbl_id, rhs)
+          NoInline        -> (gbl_id, rhs)
+          Inlinable       -> (gbl_id `setIdUnfolding` inlinable_unf, rhs)
           Inline          -> inline_pair
 
   where
@@ -230,8 +224,8 @@ makeCorePair dflags gbl_id is_default_method dict_arity rhs
     inlinable_unf = mkInlinableUnfolding dflags rhs
     inline_pair
        | Just arity <- inlinePragmaSat inline_prag
-      	-- Add an Unfolding for an INLINE (but not for NOINLINE)
-	-- And eta-expand the RHS; see Note [Eta-expanding INLINE things]
+        -- Add an Unfolding for an INLINE (but not for NOINLINE)
+        -- And eta-expand the RHS; see Note [Eta-expanding INLINE things]
        , let real_arity = dict_arity + arity
         -- NB: The arity in the InlineRule takes account of the dictionaries
        = ( gbl_id `setIdUnfolding` mkInlineUnfolding (Just real_arity) rhs
@@ -262,22 +256,22 @@ Note [Rules and inlining]
 Common special case: no type or dictionary abstraction
 This is a bit less trivial than you might suppose
 The naive way woudl be to desguar to something like
-	f_lcl = ...f_lcl...	-- The "binds" from AbsBinds
-	M.f = f_lcl		-- Generated from "exports"
+        f_lcl = ...f_lcl...     -- The "binds" from AbsBinds
+        M.f = f_lcl             -- Generated from "exports"
 But we don't want that, because if M.f isn't exported,
 it'll be inlined unconditionally at every call site (its rhs is 
 trivial).  That would be ok unless it has RULES, which would 
 thereby be completely lost.  Bad, bad, bad.
 
 Instead we want to generate
-	M.f = ...f_lcl...
-	f_lcl = M.f
+        M.f = ...f_lcl...
+        f_lcl = M.f
 Now all is cool. The RULES are attached to M.f (by SimplCore), 
 and f_lcl is rapidly inlined away.
 
 This does not happen in the same way to polymorphic binds,
 because they desugar to
-	M.f = /\a. let f_lcl = ...f_lcl... in f_lcl
+        M.f = /\a. let f_lcl = ...f_lcl... in f_lcl
 Although I'm a bit worried about whether full laziness might
 float the f_lcl binding out and then inline M.f at its call site
 
@@ -303,36 +297,36 @@ Note [Abstracting over tyvars only]
 When abstracting over type variable only (not dictionaries), we don't really need to
 built a tuple and select from it, as we do in the general case. Instead we can take
 
-	AbsBinds [a,b] [ ([a,b], fg, fl, _),
-		         ([b],   gg, gl, _) ]
-		{ fl = e1
-		  gl = e2
-		   h = e3 }
+        AbsBinds [a,b] [ ([a,b], fg, fl, _),
+                         ([b],   gg, gl, _) ]
+                { fl = e1
+                  gl = e2
+                   h = e3 }
 
 and desugar it to
 
-	fg = /\ab. let B in e1
-	gg = /\b. let a = () in let B in S(e2)
-	h  = /\ab. let B in e3
+        fg = /\ab. let B in e1
+        gg = /\b. let a = () in let B in S(e2)
+        h  = /\ab. let B in e3
 
 where B is the *non-recursive* binding
-	fl = fg a b
-	gl = gg b
-	h  = h a b    -- See (b); note shadowing!
+        fl = fg a b
+        gl = gg b
+        h  = h a b    -- See (b); note shadowing!
 
 Notice (a) g has a different number of type variables to f, so we must
-	     use the mkArbitraryType thing to fill in the gaps.  
-	     We use a type-let to do that.
+             use the mkArbitraryType thing to fill in the gaps.  
+             We use a type-let to do that.
 
-	 (b) The local variable h isn't in the exports, and rather than
-	     clone a fresh copy we simply replace h by (h a b), where
-	     the two h's have different types!  Shadowing happens here,
-	     which looks confusing but works fine.
+         (b) The local variable h isn't in the exports, and rather than
+             clone a fresh copy we simply replace h by (h a b), where
+             the two h's have different types!  Shadowing happens here,
+             which looks confusing but works fine.
 
-	 (c) The result is *still* quadratic-sized if there are a lot of
-	     small bindings.  So if there are more than some small
-	     number (10), we filter the binding set B by the free
-	     variables of the particular RHS.  Tiresome.
+         (c) The result is *still* quadratic-sized if there are a lot of
+             small bindings.  So if there are more than some small
+             number (10), we filter the binding set B by the free
+             variables of the particular RHS.  Tiresome.
 
 Why got to this trouble?  It's a common case, and it removes the
 quadratic-sized tuple desugaring.  Less clutter, hopefullly faster
@@ -377,8 +371,8 @@ thought!
 Note [Implementing SPECIALISE pragmas]
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 Example:
-	f :: (Eq a, Ix b) => a -> b -> Bool
-	{-# SPECIALISE f :: (Ix p, Ix q) => Int -> (p,q) -> Bool #-}
+        f :: (Eq a, Ix b) => a -> b -> Bool
+        {-# SPECIALISE f :: (Ix p, Ix q) => Int -> (p,q) -> Bool #-}
         f = <poly_rhs>
 
 From this the typechecker generates
@@ -396,10 +390,10 @@ well as the dict.
 
 From these we generate:
 
-    Rule: 	forall p, q, (dp:Ix p), (dq:Ix q). 
+    Rule:       forall p, q, (dp:Ix p), (dq:Ix q). 
                     f Int (p,q) dInt ($dfInPair dp dq) = f_spec p q dp dq
 
-    Spec bind:	f_spec = wrap_fn <poly_rhs>
+    Spec bind:  f_spec = wrap_fn <poly_rhs>
 
 Note that 
 
@@ -414,8 +408,8 @@ Note that
 ------------------------
 dsSpecs :: CoreExpr     -- Its rhs
         -> TcSpecPrags
-        -> DsM ( OrdList (Id,CoreExpr) 	-- Binding for specialised Ids
-	       , [CoreRule] )		-- Rules for the Global Ids
+        -> DsM ( OrdList (Id,CoreExpr)  -- Binding for specialised Ids
+               , [CoreRule] )           -- Rules for the Global Ids
 -- See Note [Implementing SPECIALISE pragmas]
 dsSpecs _ IsDefaultMethod = return (nilOL, [])
 dsSpecs poly_rhs (SpecPrags sps)
@@ -423,9 +417,9 @@ dsSpecs poly_rhs (SpecPrags sps)
        ; let (spec_binds_s, rules) = unzip pairs
        ; return (concatOL spec_binds_s, rules) }
 
-dsSpec :: Maybe CoreExpr  	-- Just rhs => RULE is for a local binding
-       	  			-- Nothing => RULE is for an imported Id
-				-- 	      rhs is in the Id's unfolding
+dsSpec :: Maybe CoreExpr        -- Just rhs => RULE is for a local binding
+                                -- Nothing => RULE is for an imported Id
+                                --            rhs is in the Id's unfolding
        -> Located TcSpecPrag
        -> DsM (Maybe (OrdList (Id,CoreExpr), CoreRule))
 dsSpec mb_poly_rhs (L loc (SpecPrag poly_id spec_co spec_inl))
@@ -434,15 +428,15 @@ dsSpec mb_poly_rhs (L loc (SpecPrag poly_id spec_co spec_inl))
     do { warnDs (ptext (sLit "Ignoring useless SPECIALISE pragma for class method selector") 
                  <+> quotes (ppr poly_id))
        ; return Nothing  }  -- There is no point in trying to specialise a class op
-       	 		    -- Moreover, classops don't (currently) have an inl_sat arity set
-			    -- (it would be Just 0) and that in turn makes makeCorePair bleat
+                            -- Moreover, classops don't (currently) have an inl_sat arity set
+                            -- (it would be Just 0) and that in turn makes makeCorePair bleat
 
   | no_act_spec && isNeverActive rule_act 
   = putSrcSpanDs loc $ 
     do { warnDs (ptext (sLit "Ignoring useless SPECIALISE pragma for NOINLINE function:")
                  <+> quotes (ppr poly_id))
        ; return Nothing  }  -- Function is NOINLINE, and the specialiation inherits that
-       	 		    -- See Note [Activation pragmas for SPECIALISE]
+                            -- See Note [Activation pragmas for SPECIALISE]
 
   | otherwise
   = putSrcSpanDs loc $ 
@@ -460,13 +454,13 @@ dsSpec mb_poly_rhs (L loc (SpecPrag poly_id spec_co spec_inl))
        { dflags <- getDynFlags
        ; let spec_unf = specUnfolding bndrs args (realIdUnfolding poly_id)
              spec_id  = mkLocalId spec_name spec_ty 
-         	            `setInlinePragma` inl_prag
-         	 	    `setIdUnfolding`  spec_unf
+                            `setInlinePragma` inl_prag
+                            `setIdUnfolding`  spec_unf
              rule =  mkRule False {- Not auto -} is_local_id
                         (mkFastString ("SPEC " ++ showPpr dflags poly_name))
-       			rule_act poly_name
-       		        rule_bndrs args
-       			(mkVarApps (Var spec_id) bndrs)
+                        rule_act poly_name
+                        rule_bndrs args
+                        (mkVarApps (Var spec_id) bndrs)
 
        ; spec_rhs <- dsHsWrapper spec_co poly_rhs
        ; let spec_pair = makeCorePair dflags spec_id False (dictArity bndrs) spec_rhs
@@ -478,21 +472,21 @@ dsSpec mb_poly_rhs (L loc (SpecPrag poly_id spec_co spec_inl))
   where
     is_local_id = isJust mb_poly_rhs
     poly_rhs | Just rhs <-  mb_poly_rhs
-             = rhs  	    -- Local Id; this is its rhs
+             = rhs          -- Local Id; this is its rhs
              | Just unfolding <- maybeUnfoldingTemplate (realIdUnfolding poly_id)
              = unfolding    -- Imported Id; this is its unfolding
-	       		    -- Use realIdUnfolding so we get the unfolding 
-			    -- even when it is a loop breaker. 
-			    -- We want to specialise recursive functions!
+                            -- Use realIdUnfolding so we get the unfolding 
+                            -- even when it is a loop breaker. 
+                            -- We want to specialise recursive functions!
              | otherwise = pprPanic "dsImpSpecs" (ppr poly_id)
-	                    -- The type checker has checked that it *has* an unfolding
+                            -- The type checker has checked that it *has* an unfolding
 
     id_inl = idInlinePragma poly_id
 
     -- See Note [Activation pragmas for SPECIALISE]
     inl_prag | not (isDefaultInlinePragma spec_inl)    = spec_inl
              | not is_local_id  -- See Note [Specialising imported functions]
-             	    		 -- in OccurAnal
+                                 -- in OccurAnal
              , isStrongLoopBreaker (idOccInfo poly_id) = neverInlinePragma
              | otherwise                               = id_inl
      -- Get the INLINE pragma from SPECIALISE declaration, or,
@@ -568,9 +562,9 @@ SPEC f :: ty                [n]   INLINE [k]
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Adding inline pragmas}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -586,12 +580,12 @@ decomposeRuleLhs bndrs lhs
         (Var fn, args) -> check_bndrs fn args
 
         (Case scrut bndr ty [(DEFAULT, _, body)], args)
-	        | isDeadBinder bndr	-- Note [Matching seqId]
-		-> check_bndrs seqId (args' ++ args)
-		where
-		   args' = [Type (idType bndr), Type ty, scrut, body]
-	   
-	_other -> Left bad_shape_msg
+                | isDeadBinder bndr     -- Note [Matching seqId]
+                -> check_bndrs seqId (args' ++ args)
+                where
+                   args' = [Type (idType bndr), Type ty, scrut, body]
+           
+        _other -> Left bad_shape_msg
  where
    opt_lhs = simpleOptExpr lhs
 
@@ -607,13 +601,13 @@ decomposeRuleLhs bndrs lhs
             -- Add extra dict binders: Note [Constant rule dicts]
        extra_dict_bndrs = [ mkLocalId (localiseName (idName d)) (idType d)
                           | d <- varSetElems (arg_fvs `delVarSetList` bndrs)
-         	          , isDictId d]
+                          , isDictId d]
 
 
    bad_shape_msg = hang (ptext (sLit "RULE left-hand side too complicated to desugar"))
                       2 (ppr opt_lhs)
    dead_msg bndr = hang (sep [ ptext (sLit "Forall'd") <+> pp_bndr bndr
-			     , ptext (sLit "is not bound in RULE lhs")])
+                             , ptext (sLit "is not bound in RULE lhs")])
                       2 (ppr opt_lhs)
    pp_bndr bndr
     | isTyVar bndr                      = ptext (sLit "type variable") <+> quotes (ppr bndr)
@@ -633,14 +627,14 @@ and thereby
 
 For (c) consider the fold/build rule, which without simplification
 looked like:
-	fold k z (build (/\a. g a))  ==>  ...
+        fold k z (build (/\a. g a))  ==>  ...
 This doesn't match unless you do eta reduction on the build argument.
 Similarly for a LHS like
-	augment g (build h) 
+        augment g (build h) 
 we do not want to get
-	augment (\a. g a) (build h)
+        augment (\a. g a) (build h)
 otherwise we don't match when given an argument like
-	augment (\a. h a a) (build h)
+        augment (\a. h a a) (build h)
 
 NB: tcSimplifyRuleLhs is very careful not to generate complicated
     dictionary expressions that we might have to match
@@ -654,12 +648,12 @@ See Note [Rules for seq] in MkId for the details.
 Note [Unused spec binders]
 ~~~~~~~~~~~~~~~~~~~~~~~~~~
 Consider
-	f :: a -> a
-	{-# SPECIALISE f :: Eq a => a -> a #-}
+        f :: a -> a
+        {-# SPECIALISE f :: Eq a => a -> a #-}
 It's true that this *is* a more specialised type, but the rule
 we get is something like this:
-	f_spec d = f
-	RULE: f = f_spec d
+        f_spec d = f
+        RULE: f = f_spec d
 Note that the rule is bogus, because it mentions a 'd' that is
 not bound on the LHS!  But it's a silly specialisation anyway, because
 the constraint is unused.  We could bind 'd' to (error "unused")
@@ -673,17 +667,17 @@ which is presumably in scope at the function definition site, we can quantify
 over it too.  *Any* dict with that type will do.
 
 So for example when you have
-	f :: Eq a => a -> a
-	f = <rhs>
-	{-# SPECIALISE f :: Int -> Int #-}
+        f :: Eq a => a -> a
+        f = <rhs>
+        {-# SPECIALISE f :: Int -> Int #-}
 
 Then we get the SpecPrag
-	SpecPrag (f Int dInt) 
+        SpecPrag (f Int dInt) 
 
 And from that we want the rule
-	
-	RULE forall dInt. f Int dInt = f_spec
-	f_spec = let f = <rhs> in f Int dInt
+        
+        RULE forall dInt. f Int dInt = f_spec
+        f_spec = let f = <rhs> in f Int dInt
 
 But be careful!  That dInt might be GHC.Base.$fOrdInt, which is an External
 Name, and you can't bind them in a lambda or forall without getting things
@@ -693,15 +687,15 @@ as the old one, but with an Internal name and no IdInfo.
 
 
 %************************************************************************
-%*									*
-		Desugaring evidence
-%*									*
+%*                                                                      *
+                Desugaring evidence
+%*                                                                      *
 %************************************************************************
 
 
 \begin{code}
 dsHsWrapper :: HsWrapper -> CoreExpr -> DsM CoreExpr
-dsHsWrapper WpHole 	      e = return e
+dsHsWrapper WpHole            e = return e
 dsHsWrapper (WpTyApp ty)      e = return $ App e (Type ty)
 dsHsWrapper (WpLet ev_binds)  e = do bs <- dsTcEvBinds ev_binds
                                      return (mkCoreLets bs e)
@@ -754,8 +748,8 @@ dsEvTerm (EvTupleSel v n)
    = do { tm' <- dsEvTerm v
         ; let scrut_ty = exprType tm'
               (tc, tys) = splitTyConApp scrut_ty
-    	      Just [dc] = tyConDataCons_maybe tc
-    	      xs = mkTemplateLocals tys
+              Just [dc] = tyConDataCons_maybe tc
+              xs = mkTemplateLocals tys
               the_x = getNth xs n
         ; ASSERT( isTupleTyCon tc )
           return $
@@ -771,7 +765,7 @@ dsEvTerm (EvTupleMk tms)
 dsEvTerm (EvSuperClass d n)
   = do { d' <- dsEvTerm d
        ; let (cls, tys) = getClassPredTys (exprType d')
-             sc_sel_id  = classSCSelId cls n	-- Zero-indexed
+             sc_sel_id  = classSCSelId cls n    -- Zero-indexed
        ; return $ Var sc_sel_id `mkTyApps` tys `App` d' }
   where
 
@@ -922,7 +916,7 @@ Note [Simple coercions]
 We have a special case for coercions that are simple variables.
 Suppose   cv :: a ~ b   is in scope
 Lacking the special case, if we see
-	f a b cv
+        f a b cv
 we'd desguar to
         f a b (case cv of EqBox (cv# :: a ~# b) -> EqBox cv#)
 which is a bit stupid.  The special case does the obvious thing.
